package regex ;

public class Matcher2 {
  private Re pat ;
  private String text ;

  // Les recherches commencent  cette position dans text
  private int regStart ;
  // La dernire sous-chane filtre est text[mStart...mEnd[
  private int mStart, mEnd ;

  Matcher2(Re pat, String text) {
    this.pat = pat ; this.text = text ;
    regStart = 0 ;       // Commencer  filtrer  partir du dbut
    mStart = mEnd = -1 ; // Aucun motif encore reconnu
  }

  // Renvoie la dernire sous-chane filtre, si il y a lieu
  public String group() {
    if (mStart == -1) throw new Error("Pas de sous-chane filtre") ;
    return text.substring(mStart, mEnd) ;
  }

  // Mthode de recherche des sous-chanes filtres a peu prs
  // conforme  celle des Matcher2 de java.util.regex
  public boolean find() {
    for (int start = regStart ; start <= text.length() ; start++) {
      int end = findLongestPrefix(start) ;
      if (end >= 0) {
        mStart = start ; mEnd = end ;
        regStart = mEnd ; // Le prochain find commencera aprs celui-ci
        return true ;
      }
    }
    mStart = mEnd = -1 ; // Pas de sous-chane reconnue
    regStart = 0 ;       // Recommencer au dbut, bizarre
    return false ;
  }
 private int findLongestPrefix(int start) {
    Re d = pat ;
    int found = -1 ;
    if (Re.nullable(d)) found = start ; // Trouv le prfixe vide
    for (int k = start ; k < text.length() ; k++) {
      d = Re.derivate(text.charAt(k), d) ;
      if (d == null) return found ;
      if (Re.nullable(d)) found=k+1 ; // Trouv le prfixe de longueur k+1-start
    }
    return found ;
  }
}
